<template>
  <b-modal
    ref="theModal"
    :title="modalTitle"
    size="xl"
    no-close-on-esc
    no-close-on-backdrop
    hide-header-close
  >
    <b-form @submit.prevent="onSave">
      <div class="row">
        <div class="col-6">
          <b-form-group label="Date display">
            <b-form-checkbox
              v-model="form.showTime"
              :value="true"
              :unchecked-value="false"
              :disabled="!canEdit"
            >
              display time
            </b-form-checkbox>
          </b-form-group>
        </div>
      </div>

      <div class="row">
        <div class="col-6">
          <b-form-group label="Date Begin (UTC)">
            <FormFieldDatepicker
              v-model="form.dateStart"
              :max-datetime="form.dateEnd"
              :type="getDatetime"
              :disabled="!canEdit"
            ></FormFieldDatepicker>
          </b-form-group>
        </div>
        <div class="col-6">
          <b-form-group label="Date End (UTC)">
            <FormFieldDatepicker
              v-model="form.dateEnd"
              :min-datetime="form.dateStart"
              :type="getDatetime"
              :disabled="!canEdit"
            ></FormFieldDatepicker>
          </b-form-group>
        </div>
      </div>

      <b-form-group label="Title internal">
        <b-form-input
          v-model="form.titleInternal"
          :disabled="!canEdit"
        ></b-form-input>
      </b-form-group>

      <div>
        <div
          v-b-toggle.translations
          class="text-link-color cursor-pointer mb-3"
        >
          toggle title translations
        </div>
        <b-collapse id="translations" :visible="canOnlyTranslate" class="pl-4">
          <b-form-group
            :label="'Title: ' + lang"
            v-for="lang in languages"
            :key="lang"
          >
            <b-form-input v-model="form.title[lang]"></b-form-input>
          </b-form-group>
        </b-collapse>
      </div>

      <div>
        <div
          v-b-toggle.translations2
          class="text-link-color cursor-pointer mb-3"
        >
          toggle teaser translations
        </div>
        <b-collapse id="translations2" :visible="canOnlyTranslate" class="pl-4">
          <b-form-group
            :label="'Teaser: ' + lang"
            v-for="lang in languages"
            :key="lang"
          >
            <b-form-textarea
              v-model="form.description[lang]"
              rows="3"
            ></b-form-textarea>
          </b-form-group>
        </b-collapse>
      </div>

      <div class="row">
        <div class="col-6">
          <b-form-group label="Preferred size">
            <b-form-select
              v-model="form.preferredSize"
              :options="boxSizes"
              :disabled="!canEdit"
            ></b-form-select>
          </b-form-group>
        </div>
        <div class="col-6">
          <b-form-group label="Options">
            <b-form-checkbox
              v-model="form.lockSize"
              :value="true"
              :unchecked-value="false"
              :disabled="!canEdit"
            >
              lock size
            </b-form-checkbox>
          </b-form-group>
        </div>
      </div>

      <b-form-group label="Link to">
        <b-form-input v-model="form.linkTo" :disabled="!canEdit"></b-form-input>
      </b-form-group>

      <b-form-group label="Image">
        <SimpleFileSelector
          v-model="form.imageId"
          :disabled="!canEdit"
        ></SimpleFileSelector>
      </b-form-group>
    </b-form>

    <b-alert :show="warnings.length > 0" variant="danger" class="mt-2">
      <div v-for="warning in warnings">
        <font-awesome-icon
          :icon="['fas', 'exclamation-triangle']"
          class="mr-2"
        ></font-awesome-icon>
        {{ warning }}
      </div>
    </b-alert>

    <template v-slot:modal-footer>
      <div class="d-flex justify-content-between w-100">
        <div>
          <b-button @click="cloneEntry" v-if="editMode" variant="light"
            >CLONE</b-button
          >
        </div>
        <div>
          <b-button @click="onCancel" variant="danger">CANCEL</b-button>
          <b-button
            @click="onSave"
            :disabled="!isValidForm"
            variant="success"
            class="ml-2"
            ><span v-if="!isCloned">SAVE</span
            ><span v-else>SAVE CLONE</span></b-button
          >
        </div>
      </div>
    </template>
  </b-modal>
</template>

<script>
import FormFieldDatepicker from '~/components/form/FormFieldDatepicker';
import SimpleFileSelector from '~/components/form/SimpleFileSelector';
import AuthorizedMixin from '~/components/security/AuthorizedMixin';
export default {
  components: { SimpleFileSelector, FormFieldDatepicker },
  mixins: [AuthorizedMixin],
  props: {
    languages: {
      type: Array,
      default: () => {
        return [];
      },
    },
    fallbackLanguage: {
      type: String,
      default: 'en',
    },
  },
  data() {
    return {
      boxSizes: ['sm', 'md', 'xl'],
      entry: null,
      isCloned: false,
      form: {
        title: {},
        description: {},
        preferredSize: 'sm',
        lockSize: false,
        showTime: true,
      },
      formDefault: {
        title: {},
        description: {},
        preferredSize: 'sm',
        lockSize: false,
        showTime: true,
      },
    };
  },
  computed: {
    warnings() {
      const warn = [];

      if (!this.form.linkTo || this.form.linkTo === '') {
        warn.push('No link set.');
      }

      if (!this.form.imageId || this.form.imageId === '') {
        warn.push('No image set.');
      }

      if (!this.form.dateStart || this.form.dateStart === '') {
        warn.push('No start date set.');
      }

      if (!this.form.dateEnd || this.form.dateEnd === '') {
        warn.push('No end date set.');
      }

      if (
        !this.form.title[this.fallbackLanguage] ||
        this.form.title[this.fallbackLanguage] === ''
      ) {
        warn.push(
          'No TITLE translation for fallback-language ' +
            this.fallbackLanguage.toUpperCase() +
            ' set.'
        );
      }

      if (
        !this.form.description[this.fallbackLanguage] ||
        this.form.description[this.fallbackLanguage] === ''
      ) {
        warn.push(
          'No TEASER translation for fallback-language ' +
            this.fallbackLanguage.toUpperCase() +
            ' set.'
        );
      }

      if (!this.form.titleInternal || this.form.titleInternal === '') {
        warn.push('No internal title set.');
      }

      return warn;
    },
    canEdit() {
      return this.isAuthorized(['NEWS_EDIT']);
    },
    canOnlyTranslate() {
      return (
        !this.isAuthorized(['NEWS_EDIT']) &&
        this.isAuthorized(['NEWS_TRANSLATE'])
      );
    },
    getDatetime() {
      return 'datetime';
    },
    editMode() {
      return this.entry !== null;
    },
    modalTitle() {
      if (this.editMode) {
        return 'Edit: ' + this.entry.titleInternal;
      }
      return 'New Event-Entry';
    },
    isValidForm() {
      return (
        this.form && this.form.titleInternal && this.form.titleInternal !== ''
      );
    },
  },
  mounted() {
    this.resetForm();
  },
  methods: {
    cloneEntry() {
      this.isCloned = true;
      this.entry = null;
      this.form.id = null;
      this.form.published = false;
    },
    resetForm() {
      this.form = JSON.parse(JSON.stringify(this.formDefault));
    },
    show(entry) {
      this.isCloned = false;
      this.resetForm();

      if (entry) {
        this.entry = entry;

        this.form = JSON.parse(JSON.stringify(entry));
      } else {
        this.entry = null;
      }

      this.$refs.theModal.show();
    },
    hide() {
      this.$refs.theModal.hide();
    },
    toggle() {
      this.$refs.theModal.toggle();
    },
    onCancel() {
      this.hide();
    },
    onSave() {
      this.$emit('save', this.entry, this.form);
    },
  },
};
</script>
